<?php
//20190129/3.0.3.1

//for_OnePagePaySOG2019-09-20Ggjournal3AiHϥ

class ControllerExtensionModuleSmilepayExt extends Controller {
	
	public function index() {
	    
	}
    public function filter_payment_c2cp(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');

        if( isset($data['payment_methods']) && $data['payment_methods'] )
        {
            if(isset( $this->session->data['shipping_method']['code']) && 
                strpos($this->session->data['shipping_method']['code'], 'smilePay_shipping_c2cp.') === 0
                )
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']!= 'smilepay_711c2c')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
            else
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']== 'smilepay_711c2c')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
           
        }
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}

    }
    public function filter_payment_c2cup(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');
        $supportid = array('smilepay_atm','smilepay_credit','smilepay_csv','smilepay_fami','smilepay_ibon');



        if( isset($data['payment_methods']) && $data['payment_methods'] &&
            isset( $this->session->data['shipping_method']['code']) &&
            strpos($this->session->data['shipping_method']['code'], 'smilePay_shipping_c2cup.') === 0
            )
        {
            foreach($data['payment_methods'] as $payment)
            {
               
                if( !in_array( $payment['code'],$supportid))
                {
                    unset($data['payment_methods'][$payment['code']]);
                }
            }
        }
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}


    }
    public function filter_payment_ezcatp(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');
        $this->load->model('extension/shipping/smilepay_ezcatp');
        $service_ids = $this->model_extension_shipping_smilepay_ezcatp->getService_code();
        if( isset($data['payment_methods']) && $data['payment_methods'] )
        {
            if(isset( $this->session->data['shipping_method']['code']) &&
                in_array($this->session->data['shipping_method']['code'],$service_ids))
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']!= 'smilepay_ezcat')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
            else
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']== 'smilepay_ezcat')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
           
        }
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}
    }
	
    public function filter_payment_ezcatup(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');
        $supportid = array('smilepay_atm','smilepay_credit','smilepay_csv','smilepay_fami','smilepay_ibon');
        $this->load->model('extension/shipping/smilepay_ezcatup');
        $service_ids = $this->model_extension_shipping_smilepay_ezcatup->getService_code();

        if( isset($data['payment_methods']) && $data['payment_methods'] &&
            isset( $this->session->data['shipping_method']['code']) 
        ){
            if( in_array( $this->session->data['shipping_method']['code'], $service_ids) )   
            {
                foreach($data['payment_methods'] as $payment)
                {
               
                    if( !in_array( $payment['code'],$supportid))
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
        }
        
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}


    }
	//2019-09-20SO}o
    public function filter_payment_c2cp_for_OnePagePay(&$route, &$data, &$output)
    {
		$smilepay_c2cp = array("smilePay_shipping_c2cp.smilePay_shipping_c2cp", "smilePay_shipping_c2cp.fami");
		$unsmilepay_c2cp="N";	
		if($data[0] == 'payment')
		{
			//echo $this->session->data['shipping_method']['code']."<br>";
			if( isset( $this->session->data['shipping_method']['code']) ) {
				if( in_array($this->session->data['shipping_method']['code'], $smilepay_c2cp)  ) {// P_WӨI
					foreach($output as $key => $payment ) {// udUWӨI
						//echo $payment['code']."<br>";
						if( $payment['code'] != 'smilepay_711c2c' ) {
							unset($output[$key]);
						}
					}
					$unsmilepay_c2cp="Y";//yWItC
				}
			}
			//pGS¿ߨItC,hNӪAȲ
			if($unsmilepay_c2cp=="N")
			{
				foreach($output as $key => $payment ) {
					if( $payment['code'] == 'smilepay_711c2c' ) {
						unset($output[$key]);
					}
				}
			}
			
			if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
			}
		}	
    }
    public function filter_payment_c2cup_for_OnePagePay(&$route, &$data, &$output)
    {
		$smilepay_c2cup = array("smilePay_shipping_c2cup.smilePay_shipping_c2cup", "smilePay_shipping_c2cup.fami");
		$supportid_c2cup = array('smilepay_atm','smilepay_credit','smilepay_csv','smilepay_fami','smilepay_ibon');
		if($data[0] == 'payment')
		{
	        if( isset( $this->session->data['shipping_method']['code']) ) {
				if( in_array($this->session->data['shipping_method']['code'], $smilepay_c2cup)  ) {// P_¿ߦvt
					foreach($output as $key => $payment ) {//R¿ߦvtPWӯ¨f
						if( !in_array( $payment['code'],$supportid_c2cup))
						{
							unset($output[$key]);
						}
					}
				}
			}
			if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
			}
		}	
    }
    public function filter_payment_ezcatp_for_OnePagePay(&$route, &$data, &$output)
    {
		$smilepay_ezcatp = array("smilepay_ezcatp.smilepay_ezcatp_normal", "smilepay_ezcatp.smilepay_ezcatp_fridge", "smilepay_ezcatp.smilepay_ezcatp_freeze");
		$unsmilepay_ezcatp="N";
		if($data[0] == 'payment')
		{
	        if( isset( $this->session->data['shipping_method']['code']) ) {
				if( in_array($this->session->data['shipping_method']['code'], $smilepay_ezcatp)  ) {// P_¿
					foreach($output as $key => $payment ) {// udU¿
						if( $payment['code'] != 'smilepay_ezcat' ) {
							unset($output[$key]);
						}
					}
					$unsmilepay_ezcatp="Y";//y¿ߨItC
				}
			}
			//pGS¿ߨItC,hNӪAȲ
			if($unsmilepay_ezcatp=="N")
			{
				foreach($output as $key => $payment ) {
					if( $payment['code'] == 'smilepay_ezcat' ) {
						unset($output[$key]);
					}
				}
			}
			
			if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
			}
		}	
    }
    public function filter_payment_ezcatup_for_OnePagePay(&$route, &$data, &$output)
    {
		$smilepay_ezcatup = array("smilepay_ezcatup.smilepay_ezcatup_normal", "smilepay_ezcatup.smilepay_ezcatup_fridge", "smilepay_ezcatup.smilepay_ezcatup_freeze");
		$supportid_ezcatup = array('smilepay_atm','smilepay_credit','smilepay_csv','smilepay_fami','smilepay_ibon');
		if($data[0] == 'payment')
		{
	        if( isset( $this->session->data['shipping_method']['code']) ) {
				if( in_array($this->session->data['shipping_method']['code'], $smilepay_ezcatup)  ) {// P_¿ߦvt
					foreach($output as $key => $payment ) {//R¿ߦvtPWӯ¨f
						if( !in_array( $payment['code'],$supportid_ezcatup))
						{
							unset($output[$key]);
						}
					}
				}
			}
			if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
			}
		}	
    }

}
?>


