<?php

class ModelExtensionShippingSmilePayEzcatup extends Model {
    const SMILEPAY_EZCATUP_SERVICE_TYPE = 'smilepay_ezcatup';
    const SMILEPAY_EZCATUP_SERVICE_ID_NORMAL = 'smilepay_ezcatup_normal';
    const SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE = 'smilepay_ezcatup_fridge';
    const SMILEPAY_EZCATUP_SERVICE_ID_FREEZE = 'smilepay_ezcatup_freeze';
	function getQuote($address) {
        // default  cost 

       if(!defined("SMILEPAY_SHIPPING_EZCATUP_MIN_TOTOAL_COST_RANGE"))
         define("SMILEPAY_SHIPPING_EZCATUP_MIN_TOTOAL_COST_RANGE",0);
        
        
       // define("SMILEPAY_SHIPPING_MAX_TOTOAL_COST_RANGE",19999);
        // set default range
        $smilePay_shipping_ezcatup_min_total_cost =SMILEPAY_SHIPPING_EZCATUP_MIN_TOTOAL_COST_RANGE;
        $smilePay_shipping_ezcatup_max_total_cost;
     
        $product_total_cost = $this->cart->getSubTotal();

		$this->load->language('extension/shipping/smilepay_ezcatup');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('shipping_smilepay_ezcatup_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if (!$this->config->get('shipping_smilepay_ezcatup_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

        //if(!isset($this->config->get('smilePay_shipping_ezcatup_free_cost')))
         //   $status = false;
       //$this->cart->getTotal();  //include tax
       //$this->cart->getSubTotal()  //  product cost

       // $product_total_cost= $total;
        $total = 0;
        $totals = array();
		$taxes = $this->cart->getTaxes();
		$total_data = array(
						'totals' => &$totals,
						'taxes'  => &$taxes,
						'total'  => &$total
					);

		//get total	
		if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
			$sort_order = array();

			$results = $this->model_setting_extension->getExtensions('total');

			foreach ($results as $key => $value) {
				$sort_order[$key] = $this->config->get('total_'.$value['code'] . '_sort_order');
			}

			array_multisort($sort_order, SORT_ASC, $results);

			foreach ($results as $result) {
				if ($this->config->get('total_'.$result['code'] . '_status')) {
					$this->load->model('extension/total/' . $result['code']);
					$this->{'model_extension_total_' . $result['code']}->getTotal($total_data, $total, $taxes);
				}
			}
					
		}
        //subtotal & total F5 logistic fee error
        // $product_total_cost = $total_data['total'];
        $free = false;
        //set free or cost
        if(  $this->config->get('shipping_smilepay_ezcatup_free_cost'))
            $product_total_cost > $this->config->get('shipping_smilepay_ezcatup_free_cost') ?$free =true :$free =false; 
      
        //filter total cost between max total cost and min total cost->
        if(!is_null($this->config->get('shipping_smilepay_ezcatup_min_total_cost')) && $this->config->get('shipping_smilepay_ezcatup_min_total_cost')!="")
            $smilePay_shipping_ezcatup_min_total_cost = $this->config->get('shipping_smilepay_ezcatup_min_total_cost');
        if(!is_null( $this->config->get('shipping_smilepay_ezcatup_max_total_cost')) && $this->config->get('shipping_smilepay_ezcatup_max_total_cost')!="")
            $smilePay_shipping_ezcatup_max_total_cost = $this->config->get('shipping_smilepay_ezcatup_max_total_cost');;
        
        if( $product_total_cost <   $smilePay_shipping_ezcatup_min_total_cost )
        {
            $status = false;
        }else if(isset( $smilePay_shipping_ezcatup_max_total_cost) && $product_total_cost > $smilePay_shipping_ezcatup_max_total_cost )
        {
            $status = false;
        }
        //<-----------------------------

        if(!is_null($this->config->get('shipping_smilepay_ezcatup_frontend_title')))
        {
          if(trim($this->config->get('shipping_smilepay_ezcatup_frontend_title')) != "" )
            $quote_data_title = $this->config->get('shipping_smilepay_ezcatup_frontend_title');
          else
            $this->language->get('text_description');
        }
        else
          $quote_data_title = $this->language->get('text_description');
       
		$method_data = array();

		if ($status) {
			$quote_data = array();
            $service_ids = $this->getService_code();
            foreach($service_ids as $key =>$val)
            {
                if(!$this->config->get('shipping_' . $key .  '_enabled'))
                {
                    continue;
                }
                if(!$free)
                {
                    $ship_cost = $this->config->get('shipping_' . $key .  '_cost');
                }
                else
                    $ship_cost = 0;
                
                $title= $this->config->get('shipping_' . $key .  '_frontend_title');

			    $quote_data[$key] = array(
				    'code'         => $val,
				    'title'        => $title,
                    'tax_class_id' => 0,
				    'cost'         => $ship_cost ,
				    'text'         =>$this->currency->format($ship_cost, $this->config->get('config_currency'))// $this->currency->format($this->config->get('smilePay_shipping_ezcatp_cost'))
			    );
            }
			$method_data = array(
				'code'       => self::SMILEPAY_EZCATUP_SERVICE_TYPE,
				'title'      =>$quote_data_title,
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('shipping_smilepay_ezcatup_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}
    public function getService_code() {
        return array(
                self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL => self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL,
                self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE => self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE,
                self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE => self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE
                );
    }
    public function getTemperature($service_id) {
        
        $data= array(
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL => '0001',
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FRIDGE => '0002',
                self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_FREEZE => '0003'
                );
        if(isset($data[$service_id]))
        {
            return $data[$service_id];
        }
        return $data[self::SMILEPAY_EZCATUP_SERVICE_TYPE . "." . self::SMILEPAY_EZCATUP_SERVICE_ID_NORMAL];
    }
}